/******************************************************************/
/*                                                                */
/*                    The D-RORC register header                  */
/*                                                                */
/******************************************************************/
/*                                                                */
/* File Name   : drorc_regs.h                                     */
/* Title       : D_RORC registers header file                     */
/* Description : Defines the registers of D-RORC.                 */
/* Authors     : Ervin Denes                                      */
/* Revisions   : 25/07/03                                         */
/*                                                                */
/******************************************************************/

/******************************************************************/
/*                                                                */
/*               Registers' structure definition                  */
/*                                                                */
/******************************************************************/

typedef struct {
  unsigned     rcsr;           /* RORC Control and Status register     */
  unsigned     rerr;           /* RORC Error register                  */
  unsigned     fwid;           /* Firmware ID                          */
  unsigned     hwid;           /* Hardware ID                          */
  unsigned     c_csr;          /* channel Control and Status register  */
  unsigned     c_err;          /* channel Error register               */
  unsigned     c_dcr;          /* channel DDL Command register         */
  unsigned     c_dsr;          /* channel DDL Status register          */
  unsigned     c_pg1;          /* channel Pattern Generator param 1    */
  unsigned     c_pg2;          /* channel Pattern Generator param 2    */
  unsigned     c_pg3;          /* channel Pattern Generator param 3    */
  unsigned     c_pg4;          /* channel Pattern Generator param 4    */
  unsigned     c_pgs;          /* channel Pattern Generator Status     */
  unsigned     c_rrbar;        /* channel Receive Report Base Address  */
  unsigned     c_rafl;         /* channel Receive Address FIFO Low     */
  unsigned     c_rafh;         /* channel Receive Address FIFO High    */
  unsigned     c_drbar;        /* channel Download Report Base Address */
  unsigned     c_dafl;         /* channel Download Address FIFO Low    */
  unsigned     c_dafh;         /* channel Download Address FIFO High   */
  unsigned     reserved;
  unsigned     c_idr1;         /* channel Input Data Rate register 1   */
  unsigned     c_idr2;         /* channel Input Data Rate register 2   */
  unsigned     c_idr3;         /* channel Input Data Rate register 3   */
  unsigned     c_idr4;         /* channel Input Data Rate register 4   */
  unsigned     c_odr1;         /* channel Output Data Rate register 1  */
  unsigned     c_odr2;         /* channel Output Data Rate register 2  */
  unsigned     c_odr3;         /* channel Output Data Rate register 3  */
  unsigned     c_odr4;         /* channel Output Data Rate register 4  */
} rorc_regs;

