#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
//#include "nios2_system.h"
//#include <io.h>
//#include <unistd.h>
//#include "miszel_avalon_jtag_regs.h"
//#include "miszel_avalon_jtag_routines.h"
//#include "miszel_avalon_jtag_routines.c"

int select_chip(int chips);
int change_settings_ro(int unsigned *data);
int change_settings_bias(int unsigned *data);
int change_settings_cdis(int unsigned *data);
int display_data(int lines, int unsigned *data);
int display_data2(char *format,int entries, int chips, int unsigned *data);
int power(int val, int pow);
int initialize_data( int chips, int values, char delimeter, char comment, char *input_format, char *path, int unsigned *data);
int build(FILE *p, int a,int b);
int rorc_miszel_avalon_jtag_read_write(FILE *output_file, unsigned int select_register, unsigned int select_register_length_in_bits, unsigned int data_length_in_bits, unsigned int *data);
int rorc_miszel_jtag_write_register(FILE *output_file, int address, unsigned int data);
int rorc_miszel_jtag_read_register(FILE *output_file, int address);
int rorc_miszel_avalon_jtag_reset(FILE *output_file);
int rorc_read_back(char *path, unsigned int *data);

#define JTAG_ADDRESS_DATA                   0x0
#define JTAG_ADDRESS_REG_SEL                0x1
#define JTAG_ADDRESS_DATA_LENGTH            0x2
#define JTAG_ADDRESS_STATUS                 0x3

#define JTAG_SATUS_WRITE_DO					0x1
#define JTAG_SATUS_WRITE_CANCEL_DO			0x0
#define JTAG_SATUS_WRITE_NEXT_WORD_READY	0x2
#define JTAG_SATUS_WRITE_RESET				0x4

#define JTAG_SATUS_READ_IDLE				0x1
#define JTAG_SATUS_READ_BUSY				0x0
#define JTAG_SATUS_READ_WAIT_NEXT_WORD		0x2
#define JTAG_SATUS_READ_RESET				0x4

int main(int argc, char *argv[])
{
    int i,j,l,x;     
    int chips;
    int regSel;
    int dataLength;
    int regLength;
    int chip_no;
    
	char path[100]={"\n"};
    char comparison[20]={"\n"};
    
	FILE *rorcFile;
	rorcFile = fopen("rorc.dat","w");
    
    if (argc == 2){
       if (argv[1][0]=='r'){
          printf("RESET\n");
//          miszel_avalon_jtag_reset(na_my_jtag);
           rorc_miszel_avalon_jtag_reset(rorcFile);
          exit(0);

       }
       else if (strcmp(argv[1],"--help")==0){
       printf("Usage: %s [option0]\nUsage: %s [number] [register] [option2] [FILE]\n",argv[0],argv[0]);
       printf(" option0: \n        --help  this help for the usage of the procedure\n");
       printf("        r        reset JTAG programmer and all daisy chained MimoStar chips\n");
       printf(" number: \n        int     number of MimoStar2 chips conected in the daisy chain\n");
       printf(" register: \n        r        readout mode\n        b        DAC settings\n        d        Disabled Columns\n");
       printf(" option: \n        auto    automatic programming with initial settings\n");
       printf("        user    interactive menu for adjusting settings before programming\n");
       printf(" FILE:\n        path    file with initial settings for each chip\n");
       exit(0);
       }
       else
       {
       printf("wrong parameter\n");
       exit(0);
       }
    }  
           
    if (argc != 5 && argc != 2){
         printf(" wrong number of parameters \n");
         exit(0);
    }
    
    chips = atoi(argv[1]);     
    if (chips<=0 || chips >7){
                 printf(" wrong number of chips. Should be 1-7\n");
                 exit(0);
    }
    
    FILE *initFile;
	initFile = fopen (argv[4], "r");
    
	
	if (initFile==NULL)
	{
     printf("wrong data path\n");
     exit(0);
    }
    else fclose(initFile);
// initialize data
    //int dac_init[]={40,50,100,33,35,20,50,100,33,60,155,150,30,0};
    //int ro_init[]={0,0,0,1,0,1};
    
    int unsigned *word_send = (int unsigned *) malloc(chips*4 * sizeof(int));
    if (word_send==NULL) return -1; 
	int unsigned *word_copy = (int unsigned *) malloc(chips*4 * sizeof(int)); 
// end initialize data    
    
    
    int unsigned *ro_mode =  (int unsigned *) calloc(6*chips, sizeof(int));
    if (ro_mode==NULL) {return 1;} 
    int unsigned *dac_bias = (int unsigned *) calloc((14*chips + 3), sizeof(int));   // +3 for dummy sets to fill full words
    if (dac_bias==NULL) {return 1;}
    int unsigned *dis_cols = (int unsigned *) calloc(4*chips,sizeof(int));
    if (dis_cols==NULL) {return 1;}
    
    switch (argv[2][0])
    {
           case 'r':
                dataLength = 6*chips;
                regLength = 5*chips-1;
                regSel = 0x17;
                printf("programming RO-mode:\n ");
                
                if(initialize_data( chips, 6,'r','#', "%i", argv[4],ro_mode) < 0)
                {exit(0);}
                
                if (strcmp(argv[3],"auto")==0){
                  }
                else if (strcmp(argv[3],"user")==0){
                     printf("call user cofing\n");
                     while(1){
                     chip_no = select_chip(chips);         
                     if (chip_no >=0)
                     change_settings_ro(ro_mode+6*chip_no);
                     else break;
                     }
                }
                else 
                {
                printf("wrong switch for programming (%s) (user/auto)\n",argv[3]);
                exit(0);
                }                     
                // build programming words
                for (i=0; i<dataLength/32+1; i++){
                  word_send[i]=0;
                  if (i<dataLength/32){
                     for (j=0; j<32; j++){
                      word_send[i]+=power(2,j)*ro_mode[j+32*i];
					  word_copy[i]=word_send[i];					  
                      }
                  }    
                  else
                  {                     
                  for (j=0; j<dataLength%32; j++){
                      word_send[i]+=power(2,j)*ro_mode[j+32*i];
					  word_copy[i]=word_send[i];
                      }
                  }
                }
                // end building programming words 
                printf(" sent data:\n");
                display_data2("%i ",6,chips,ro_mode);
                //display_data(i, word_send);
                printf("PROGRAMMING\n");
//                miszel_avalon_jtag_read_write(na_my_jtag, regSel,regLength, dataLength, word_send);
                  rorc_miszel_avalon_jtag_read_write(rorcFile, regSel, regLength, dataLength, word_send);
				fclose(rorcFile);
				  printf("select the file for comparison: ");
                scanf("%s",path);
                rorc_read_back(path, word_send);
                
                for ( x=0; x<i;x++){
                    //printf("compare %08x with %08x\n",word_send[x],word_copy[x]);
                     if (word_send[x] != word_copy[x]){              
                        strcpy(comparison,"\nDIFFERENCES\n");
                        break;
                     }
                     else strcpy(comparison,"\nTHE SAME\n");
                }
                
				printf(" received previous settings:\n");
                //display_data(i, word_send);

                int k,m;
                for (m=i-1; m>=0; m--){
                    if (m==i-1){
                       for (k=0; k<j; k++){
                           ro_mode[m*6+k] = word_send[m]%2;
                           word_send[m]/=2;
                       }
                    }
                    else 
                    {
                       for (k=0; k<32; k++){
                           ro_mode[m*6+k] = word_send[m]%2;
                           word_send[m]/=2;
                       }
                    }   
                }
                
                display_data2("%i ",6,chips,ro_mode);
				printf("%s",comparison);
                break;

           case 'b':
                dataLength = 112*chips;
                regLength = 5*chips-1;
                regSel = 0x10;
                printf("program DACS\n");
                
                if (initialize_data( chips, 14, 'b', '#', "%i", argv[4],dac_bias)<0)
                {exit(0);}
                dac_bias[chips*14 + 0] = 0;
                dac_bias[chips*14 + 1] = 0;
                dac_bias[chips*14 + 2] = 0;  
                // end initalization
                
                if (strcmp(argv[3],"auto")==0){
                  }
                else if (strcmp(argv[3],"user")==0){
                     printf("call user cofing\n");
                     while(1){
                     chip_no = select_chip(chips);         
                     if (chip_no >=0)
                     change_settings_bias(dac_bias+14*chip_no);
                     else break;
                     }
                }
                else 
                {
                printf("wrong switch for programming (%s) (user/auto)\n",argv[3]);
                exit(0);
                }
                // build programming words
                for (l=0, m=0; l<14*chips; l+=4, m++){
                 word_send[m]= dac_bias[l] + dac_bias[l+1] *256 + dac_bias[l+2] *256*256 + dac_bias[l+3] * 256*256*256;
				 word_copy[m]=word_send[m];
                 }
                // end building programming words 
                printf(" sent data:\n");
                display_data2("%3i ",14,chips,dac_bias);
                display_data(m, word_send);
                printf("PROGRAMMING\n");
//                miszel_avalon_jtag_read_write(na_my_jtag, regSel, regLength, dataLength, word_send);
                  rorc_miszel_avalon_jtag_read_write(rorcFile, regSel, regLength, dataLength, word_send);
				fclose(rorcFile);
				  printf("select the file for comparison: ");
                scanf("%s",path);
                rorc_read_back(path, word_send);
                
                for (x=0; x<m;x++){
                    //printf("compare %08x with %08x\n",word_send[x],word_copy[x]);
                     if (word_send[x] != word_copy[x]){              
                        strcpy(comparison,"\nDIFFERENCES\n");
                        break;
                     }
                     else strcpy(comparison,"\nTHE SAME\n");
                }
                				
				printf(" received previous settings:\n");
                //display_data(m, word_send);
                for (k=0; k<m; k++){
                    for (l=0; l<4; l++){
                           dac_bias[k*4+l] = word_send[k]%256;
                           word_send[k]/=256;
                       }
                }
                display_data2("%3i ",14,chips,dac_bias);
                printf("%s",comparison);
                break;
                
           case 'd':
                dataLength = 128*chips;
                regLength = 5*chips-1;
                regSel = 0x11;      
                printf("program COLS\n");

                if (initialize_data(chips, 4, 'd', '#', "%x", argv[4], dis_cols)<0)
                {exit(0);}

                if (strcmp(argv[3],"auto")==0){
                  }
                else if (strcmp(argv[3],"user")==0){
                     printf("call user cofing\n");
                     while(1){
                     chip_no = select_chip(chips);         
                     if (chip_no >=0)
                     change_settings_cdis(dis_cols+4*chip_no);
                     else break;
                     }
                }
                else 
                {
                printf("wrong switch for programming (%s) (user/auto)\n",argv[3]);
                exit(0);
                }
                // build programming words
                for (l=0; l<4*chips; l++){
                 word_send[l]= dis_cols[l];
				 word_copy[l]=word_send[l];
                 }
                // end building programming words 
                printf(" sent data:\n");
                display_data2("%08x ",4,chips,dis_cols);                
                //display_data(l, word_send);
                printf("PROGRAMMING\n");
				//                miszel_avalon_jtag_read_write(na_my_jtag, regSel, regLength, dataLength, word_send);
                  rorc_miszel_avalon_jtag_read_write(rorcFile, regSel, regLength, dataLength, word_send);
                fclose(rorcFile);
				printf("select the file for comparison: ");
                scanf("%s",path);
                rorc_read_back(path, word_send);
                
                for (x=0; x<l;x++){
                    //printf("compare %08x with %08x\n",word_send[x],word_copy[x]);
                     if (word_send[x] != word_copy[x]){              
                        strcpy(comparison,"\nDIFFERENCES\n");
                        break;
                     }
                     else strcpy(comparison,"\nTHE SAME\n");
                }
                
				printf(" received previous settings:\n");
                //display_data(l, word_send);

                for (l=0; l<4*chips; l++){
                 dis_cols[l]=word_send[l];
                 }
                display_data2("%08x ",4,chips,dis_cols);
				
				printf("%s",comparison);
                break;     
           default:
                printf("wrong switch for registers (r,b,d)\n");
                exit(0);
                break;
    }

 return 0;
}


/**************************************************/
int select_chip(int chips)
{
char buffer[80];
buffer[0]='x';
int i;
int one_chip;
while (buffer[0] != 'e')
    {
    i=0;
    printf("            \\\\\\\\ \n");
    printf("            ($ $) \n");
    printf("========-o00-(_)-00o-================\n\n");
    printf("Select your option\n");
    for (i=0; i<chips; i++){
        printf(" (%i) configure MimoStar chip no. %i\n",i,i);
        }
    printf(" (e) EXIT\n");
    printf("=====================================\n");
    scanf("%s",buffer);
    switch (buffer[0])
    {
           case 'e':
                break;
           default :
                one_chip=atoi(buffer);
                if(one_chip>=0 && one_chip<chips){
                return one_chip;
                }
                break;
    }
    printf("\n\n\n\n\n\n\n\n\n\n\n\n");
    }
    return -1;    
}
/**************************************************/
int change_settings_ro(int unsigned *data)
{
    char buffer[80];
    int value;
    int param=1;
    printf("These are the default settigns for RO mode:\n");
    printf (" Norm/Test | Diff/S-E | Ser/Par |  G 5/3 |  Px/Mx  |CMOS/LVDS\n" );
    printf ("   %3i     |    %3i   |   %3i   |   %3i  |   %3i   |   %3i   \n", data[0],data[1],data[2],data[3],data[4],data[5]);
    while (param!=0)
    {
        printf("choose the parameter 1-6 or 0 to leave ... ");
        scanf("%s",buffer);
        param = atoi(buffer);
        if (param > 0 && param <7)
        {
         printf("change %i  ->  ", data[param-1]);
         scanf("%s",buffer);
         value = atoi(buffer);
         if (value >=0 && value<2){
         data[param-1]=value;
         printf ("The current settigns for RO mode are:\n");
         printf (" Norm/Test | Diff/S-E | Ser/Par |  G 5/3 |  Px/Mx  |CMOS/LVDS\n" );
         printf ("   %3i     |    %3i   |   %3i   |   %3i  |   %3i   |   %3i   \n", data[0],data[1],data[2],data[3],data[4],data[5]);
         }
        }
    }
    return 0;
}
/**************************************************/
int change_settings_bias(int unsigned *data)
{
    char buffer[80];
    int param=1;
    int value;
    printf("These are the default settigns for DACs\n");
    printf (" (1)I4FB | (2)V4FB | (3)I4FI | (4)I4R2 | (5)V4R2 | (6)I4BD | (7)I4BS | (8)I4AM\n" );
    printf ("    %3i  |    %3i  |    %3i  |    %3i  |    %3i  |    %3i  |    %3i  |    %3i  \n", data[0],data[1],data[2],data[3],data[4],data[5],data[6],data[7] );
    printf (" (9)I4R1 |(10)V4R1 |(11)V4T0 |(12)V4T1 |(13)I4PX |(14)IKIM \n" );
    printf ("    %3i  |    %3i  |    %3i  |    %3i  |    %3i  |    %3i  \n", data[8],data[9],data[10],data[11],data[12],data[13]);
    while (param!=0)
    {
        printf("choose the parameter 1-14 or 0 to leave ... ");
        scanf("%s",buffer);
        param = atoi(buffer);
        if (param > 0 && param < 15)
        {
         printf("change %i  ->  ", data[param-1]);
         scanf("%s",buffer);
         value = atoi(buffer);
         if (value>=0 && value < 256){
         data[param-1]=value;
         printf ("The current settigns for BIAS are:\n");
         printf (" (1)I4FB | (2)V4FB | (3)I4FI | (4)I4R2 | (5)V4R2 | (6)I4BD | (7)I4BS | (8)I4AM\n" );
         printf ("    %3i  |    %3i  |    %3i  |    %3i  |    %3i  |    %3i  |    %3i  |    %3i  \n", data[0],data[1],data[2],data[3],data[4],data[5],data[6],data[7] );
         printf (" (9)I4R1 |(10)V4R1 |(11)V4T0 |(12)V4T1 |(13)I4PX |(14)IKIM \n" );
         printf ("    %3i  |    %3i  |    %3i  |    %3i  |    %3i  |    %3i  \n", data[8],data[9],data[10],data[11],data[12],data[13]);
         }
        }
    }
    return 0;
}
/**************************************************/
int change_settings_cdis(int unsigned *data)
{
    char buffer[80];
    int dec_num;
    int param=1;

    printf("These are the default settigns for disabled columns: \n");
    printf (" (MSB) SET4 |   SET3   |   SET2   |   SET1(LSB)\n" );
    printf ("   %08x | %08x | %08x | %08x \n", data[3],data[2],data[1],data[0]);
    while (param!=0)
    {
        printf("choose the parameter 1-4 or 0 to leave ... ");
        scanf("%s",buffer);
        param = atoi(buffer);
        if (param >0 && param < 5)
        {
         printf("change %08x  ->  ", data[param-1]);
         scanf("%s",buffer);
         sscanf(buffer,"%8x",&dec_num);
        // if (dec_num >=0 && dec_num<=4294967295){
         data[param-1]=dec_num;
         printf ("The current settigns for disabled columns are:\n");
         printf (" (MSB) SET4 |   SET3   |   SET2   |   SET1(LSB)\n" );
         printf ("   %08x | %08x | %08x | %08x \n", data[3],data[2],data[1],data[0]);
         }
    }

    return 0;
}
/**************************************************/
int display_data(int lines, int unsigned *data)
{
 int l;    
 for (l=0; l<lines; l++){
    printf(" %08x ",data[l]);
    }
 printf("\n");
 return 0;
}    
/**************************************************/
int display_data2(char *format,int entries, int chips, int unsigned *data)
{
 int i,j;

 printf(" MSB -> LSB\n");
 for (i=0; i<chips; i++){
    printf(" chip%i: ",i);
    for (j=0; j<entries; j++){
        printf(format,data[entries*(i+1)-1 - j]);
        }
        printf("\n");
    }
 
 return 0;
}    
/**************************************************/
int power(int val, int pow)
{   int ret_val = 1;
    int i;
        for(i = 0; i < pow; i++)
                ret_val *= val;
        return(ret_val);
}
/**************************************************/
int initialize_data( int chips, int values, char delimeter, char comment, char *input_format, char *path, int unsigned *data)
{
    int unsigned dec_num;
    char buffer[300];
    char check;
    char marker[10];
    int i,j;
    
    sprintf(marker,"%%*[^%c]%%s",delimeter);
        
    
    FILE *myFile;
	myFile = fopen (path, "r");
	if (myFile==NULL)
	{
     printf("wrong data path\n");
     exit(0);
    }
    else 
    {
	for ( i=0; i<chips; i++){
        check=fgetc(myFile);
            if (feof(myFile)==1) break;              
        	if (check != '#'){
                 ungetc(check, myFile);
                 fscanf(myFile, marker, buffer);                 
                 for (j=0; j<values; j++){
                 fscanf(myFile, "%s", buffer);
                 sscanf(buffer,input_format,&dec_num);
                 data[values*i+j]=dec_num;
                  }
            fgets(buffer,300,myFile);    
            }
            else 
            {
                fgets(buffer,300,myFile);
                i--;
            }     

      }               
    
    fclose (myFile);
    }
return 0;
}
/**************************************************/
int build(FILE *p, int a,int b){
 fprintf(p, "0x%08lx ", a*65536+b);
return 0;
};
/**************************************************/
int rorc_miszel_jtag_write_register(FILE *output_file, int address, unsigned int data){
  unsigned int data_LSB = data%65536;
  unsigned int data_MSB = data/65536;
  
  build(output_file,0x9,address+4);
  build(output_file,0xb,data_MSB);
  build(output_file,0xa,data_LSB);
  build(output_file,0x8,0);
  fprintf(output_file,"\n");
return 0;
}
/**************************************************/
int rorc_miszel_jtag_read_register(FILE *output_file, int address){
  build(output_file,0x9,address);
  build(output_file,0x8,0);
  fprintf(output_file,"\n");
  if (address==JTAG_ADDRESS_DATA){
  	build(output_file,0x7,0x3);
	fprintf(output_file,"\n");
  }
}

/**************************************************/
int rorc_miszel_jtag_wait(FILE *output_file, unsigned int data){
  build(output_file,0xc,data);
  fprintf(output_file,"\n");
}
/**************************************************/
int rorc_miszel_avalon_jtag_read_write(FILE *output_file, unsigned int select_register, unsigned int select_register_length_in_bits, unsigned int data_length_in_bits, unsigned int *data){
  int jtag_data_length_in_bits = data_length_in_bits - 1;
  int number_of_words;
  int i;
  if ((data_length_in_bits % 32) > 0)
  {
	number_of_words = data_length_in_bits / 32 + 1;
  }
  else
  {
  number_of_words = data_length_in_bits / 32;
  }
  rorc_miszel_jtag_write_register(output_file, JTAG_ADDRESS_REG_SEL,select_register);
  rorc_miszel_jtag_write_register(output_file, JTAG_ADDRESS_DATA_LENGTH,select_register_length_in_bits);
  rorc_miszel_jtag_write_register(output_file, JTAG_ADDRESS_DATA,data[0]); 
  rorc_miszel_jtag_write_register(output_file, JTAG_ADDRESS_STATUS,JTAG_SATUS_WRITE_DO);
  rorc_miszel_jtag_wait(output_file,JTAG_SATUS_READ_BUSY);
  rorc_miszel_jtag_write_register(output_file, JTAG_ADDRESS_STATUS,JTAG_SATUS_WRITE_CANCEL_DO);
  rorc_miszel_jtag_wait(output_file,JTAG_SATUS_READ_WAIT_NEXT_WORD);
  
  rorc_miszel_jtag_write_register(output_file, JTAG_ADDRESS_DATA_LENGTH,jtag_data_length_in_bits);
  rorc_miszel_jtag_read_register(output_file, JTAG_ADDRESS_STATUS);
  rorc_miszel_jtag_write_register(output_file, JTAG_ADDRESS_STATUS,JTAG_SATUS_WRITE_NEXT_WORD_READY);
  if (number_of_words > 1) {
        for ( i = 1; i < number_of_words; i++) {
	    rorc_miszel_jtag_read_register(output_file, JTAG_ADDRESS_STATUS);
            rorc_miszel_jtag_wait(output_file,JTAG_SATUS_READ_WAIT_NEXT_WORD);
			// save the data read from JTAG
	    rorc_miszel_jtag_read_register(output_file, JTAG_ADDRESS_DATA);
			//data[i-1] = IORD_MISZEL_AVALON_JTAG_DATA(address);
			// programm the new word
	    rorc_miszel_jtag_write_register(output_file, JTAG_ADDRESS_DATA,data[i]);
			// confirm avaliability of the new word
            rorc_miszel_jtag_write_register(output_file, JTAG_ADDRESS_STATUS,JTAG_SATUS_WRITE_NEXT_WORD_READY);
		}
    }
    // save the last data read form JTAG
	rorc_miszel_jtag_read_register(output_file, JTAG_ADDRESS_STATUS);
	rorc_miszel_jtag_wait(output_file,JTAG_SATUS_READ_IDLE);
    
	rorc_miszel_jtag_read_register(output_file, JTAG_ADDRESS_DATA);
    //data[number_of_words-1] = IORD_MISZEL_AVALON_JTAG_DATA(address);
	
	return 0;  
}
/**************************************************/
int rorc_miszel_avalon_jtag_reset(FILE *output_file)
{
 int i;
 int temp;
 int length = 10;
 for ( i=0; i <length; i++)
			{
			rorc_miszel_jtag_write_register(output_file, JTAG_ADDRESS_STATUS,JTAG_SATUS_WRITE_RESET);
			}
 rorc_miszel_jtag_write_register(output_file, JTAG_ADDRESS_STATUS, 0x0 );
return 0;
}
/**************************************************/

int rorc_read_back(char *path, unsigned int *data){

int i=0;
unsigned int dec_num=1;
char check;
char buffer[1000]={"\n"};

FILE *readFile;
readFile = fopen (path, "r"); 
if (readFile==NULL)
	{
     printf("wrong data path\n");
     exit(0);
    }
    else
    {
     check=fgetc(readFile);
     if (feof(readFile)==1) return -1;
     if (check == '#'){
        fgets(buffer,300,readFile);
     }
     while (dec_num != 0){
        fscanf(readFile," 0x%x",&dec_num);
        data[i]=dec_num;
        if (dec_num != 0) printf(" %08x ",dec_num);
        i++;
     } 
     printf("\n");           
     i--;
     }
 return 0;
}
/**************************************************/
