#ifndef _RORC_DATE_H_
#define _RORC_DATE_H_

/*
 ***************************************************
 * rorc_date.h
 *
 * Header file for ALICE RORC programs used in DATE
 *
 * last updated: 09/05/2003
 * written by: Peter Csato and Ervin Denes
 ***************************************************
 */

/* info logger */

#ifdef DATE_LOG   //DATE_LOG
  #define LOG_FACILITY "DDL test"
  #include "infoLogger.h"
  #include "rcShm.h"
  #define DDL_STREAM "logDDL"
  #define date_log(message...) \
          if (LOGLEVEL >= LOG_NORMAL_TH) \
            (sprintf (logLine, message), LOG_TO (DDL_STREAM, LOG_INFO, logLine))
  char logLine[128];
#else
  #define date_log(message...) ( printf(message), printf("\n") )
#endif

#endif /* _RORC_DATE_H_ */

