#ifndef _RORC_DRIVER_H_
#define _RORC_DRIVER_H_

/*
 ***************************************************
 * rorc_driver.h
 *
 * Header file for ALICE RORC driver
 *
 * last updated: 25/07/2003
 * written by: Ervin Denes
 ***************************************************
 */

#include "rorc.h"

/*
 * One rorc_t per RORC card keeps track of all driver information
 */

typedef struct
{
  struct pci_dev* pcidev;              /* The result of the pci_find_device() */
  int id;                              /* 0, 1, ... etc. */
  char name[32];                       /* rorc0, rorc1, ... etc. */
  volatile rorc_regs* opreg;           /* Memory mapped bar0 or bar1 reg. */
  volatile s593x_regs* amccreg;        /* Memory mapped AMCC S593X regs */
  unsigned char revision;              /* 1 = pRORC, 
                                          2 = D-RORC with pluggable DIU
                                          3 = integrated D-RORC and DIU */
  unsigned int pid[MAX_CHANNEL];       /* 0 = closed, pid = PID of open() */
} rorc_t;

#endif /* _RORC_DRIVER_H */
